package io.zipcoder;

import java.util.ArrayList;
import java.util.HashMap;

public class Items extends ArrayList<Item>{

    public Items getMilks() {
        Items milkItems = new Items();
        for(Item item : this) {
            if(item.getName().equalsIgnoreCase("Milk")) {
                milkItems.add(item);
            }
        }
        return milkItems;
    }

    public Items getBread() {
        Items breadItems = new Items();
        for(Item item : this) {
            if(item.getName().equalsIgnoreCase("Bread")) {
                breadItems.add(item);
            }
        }
        return breadItems;
    }

    public Items getCookies() {
        Items cookiesItems = new Items();
        for(Item item : this) {
            if(item.getName().equalsIgnoreCase("Cookies")) {
                cookiesItems.add(item);
            }
        }
        return cookiesItems;
    }

    public Items getApples() {
        Items applesItems = new Items();
        for(Item item : this) {
            if(item.getName().equalsIgnoreCase("Apples")) {
                applesItems.add(item);
            }
        }
        return applesItems;
    }

    public HashMap<Double, Integer> getPriceCount() {

        HashMap<Double, Integer> priceMap = new HashMap<>();

        for(Item item : this) {
            if(priceMap.containsKey(item.getPrice())) {
                int count = priceMap.get(item.getPrice());
                count = count + 1;
                priceMap.put(item.getPrice(), count);
            } else {
                priceMap.put(item.getPrice(), 1);
            }
        }

        return priceMap;
    }

    public static String prettyOutput(Items milk, HashMap<Double, Integer> milkPrices, Items bread, HashMap<Double, Integer> breadPrices, Items cookies, HashMap<Double, Integer> cookiesPrices, Items apples, HashMap<Double, Integer> applesPrices) {

        String result = String.format("%-8s %4s %12s %d %6s", "name:", "Milk", "seen:", milk.size(), "times\n") +
                String.format("%12s %6s %13s", "=============", "", "=============\n");
        for(Double priceM : milkPrices.keySet()) {
                result += String.format("%-8s %.2f %12s %d %6s", "Price:", priceM, "seen:", milkPrices.get(priceM), "times\n") +
                        String.format("%12s %6s %13s", "-------------", "", "-------------\n");
            }

            result += String.format("%-8s %4s %12s %d %6s", "\nname:", "Bread", "seen:", bread.size(), "times\n") +
                String.format("%12s %6s %13s", "=============", "", "=============\n");
        for(Double priceB : breadPrices.keySet()) {
            result += String.format("%-8s %.2f %12s %d %6s", "Price:", priceB, "seen:", breadPrices.get(priceB), "times\n") +
                    String.format("%12s %6s %13s", "-------------", "", "-------------\n");
        }

        result += String.format("%-5s %4s %12s %d %6s", "\nname:", "Cookies", "seen:", cookies.size(), "times\n") +
                String.format("%12s %6s %13s", "=============", "", "=============\n");
        for(Double priceC : cookiesPrices.keySet()) {
            result += String.format("%-8s %.2f %12s %d %6s", "Price:", priceC, "seen:", cookiesPrices.get(priceC), "times\n") +
                    String.format("%12s %6s %13s", "-------------", "", "-------------\n");
        }

        result += String.format("%-7s %4s %12s %d %6s", "\nname:", "Apples", "seen:", apples.size(), "times\n") +
                String.format("%12s %6s %13s", "=============", "", "=============\n");
        for(Double priceA : applesPrices.keySet()) {
            result += String.format("%-8s %.2f %12s %d %6s", "Price:", priceA, "seen:", applesPrices.get(priceA), "times\n") +
                    String.format("%12s %6s %13s", "-------------", "", "-------------\n");
        }

        result += String.format("%-12s %14s %d %5s", "\nErrors", "seen:", ItemParseException.getCount(), "times");

        return result;

    }

}
