package io.zipcoder;

import org.apache.commons.io.IOUtils;

import java.util.ArrayList;
import java.util.HashMap;


public class Main {

    public String readRawDataToString() throws Exception{
        ClassLoader classLoader = getClass().getClassLoader();
        String result = IOUtils.toString(classLoader.getResourceAsStream("RawData.txt"));
        return result;
    }

    public static void main(String[] args) throws Exception {
        String output = (new Main()).readRawDataToString();
        ItemParser itemParser = new ItemParser();
        ArrayList<String> strItems = itemParser.parseRawDataIntoStringArray(output);
        Item item = null;
        Items items = new Items();
        for(String itemStr : strItems) {
            HashMap<String, String> itemMap = itemParser.mapKeysAndValuesOfItem(itemStr);

            try {
                item = itemParser.parseStringIntoItem(itemMap);
                items.add(item);
            } catch (ItemParseException e) {
            }

        }
        Items milkItems = items.getMilks();
        HashMap<Double, Integer> milkPrices = milkItems.getPriceCount();
        Items breadItems = items.getBread();
        HashMap<Double, Integer> breadPrices = breadItems.getPriceCount();
        Items cookieItems = items.getCookies();
        HashMap<Double, Integer> cookiePrices = cookieItems.getPriceCount();
        Items appleItems = items.getApples();
        HashMap<Double, Integer> applePrices = appleItems.getPriceCount();

        output = Items.prettyOutput(milkItems, milkPrices, breadItems, breadPrices, cookieItems, cookiePrices, appleItems, applePrices);

        System.out.println(output);
    }
}
