package io.zipcoder;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import java.util.HashMap;

public class ItemsTest {

    Items items = new Items();

    @Before
    public void setUp() throws Exception {
        Item item1 = new Item("Milk", 3.40, "Food", "11/12/2020");
        Item item2 = new Item("Milk", 1.45, "Food", "11/12/2020");
        Item item3 = new Item("Milk", 3.40, "Food", "12/5/2020");
        Item item4 = new Item("Cookies", 1.75, "Food", "11/12/2020");
        Item item5 = new Item("Apples", 0.75, "Food", "11/12/2020");
        Item item6 = new Item("Bread", 1.00, "Food", "11/12/2020");
        Item item7 = new Item("Bread", 1.40, "Food", "11/12/2020");
        Item item8 = new Item("Bread", 1.00, "Food", "11/12/2020");

        items.add(item1);
        items.add(item2);
        items.add(item3);
        items.add(item4);
        items.add(item5);
        items.add(item6);
        items.add(item7);
        items.add(item8);
    }

    @Test
    public void testGetMilk() {
        Items milkItems = items.getMilks();
        int expected = 3;
        int actual = milkItems.size();
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testGetBread() {
        Items breadItems = items.getBread();
        int expected = 3;
        int actual = breadItems.size();
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testGetCookies() {
        Items cookieItems = items.getCookies();
        int expected = 1;
        int actual = cookieItems.size();
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testGetApples() {
        Items appleItems = items.getApples();
        int expected = 1;
        int actual = appleItems.size();
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testGetMilkPrices() {
        Items milkItems = items.getMilks();
        HashMap<Double, Integer> milkPrices = milkItems.getPriceCount();
        Assert.assertEquals(2, (int) milkPrices.get(3.40));
        Assert.assertEquals(1, (int) milkPrices.get(1.45));
    }
}
